#pragma once

#include <list>
#include <set>

#include "memory.h"



/* A memory pool preallocating its memory. */

class MemoryPreallocated : public Memory
{
protected:
    unsigned int _limit;
    std::list<Region *> _free;
    std::set<Region *> _used;

public:
    explicit MemoryPreallocated(unsigned int limit, offset_t region_size=PAGE_SIZE);

    virtual ~MemoryPreallocated();

    virtual bool allocated();

    virtual Region *region();

    virtual void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
